'---------------------------------------------------------------------
'      Name:   DEFINE_A.INC
'     Stand:   10. Januar 2005
'     Zweck:   INCLUDE-Datei mit allgemein verwendeten Symbolen
'              Verwendung ausserhalb der MAIN Task.
'              Siehe auch: DEFINE_I.INC
'
' Copyright:   (C) 2000 Wilke Technology GmbH, 52018 Aachen, Germany
'---------------------------------------------------------------------


'---------------------------------------------------------------------
' Namen fuer Ports der Device-Treiber
'---------------------------------------------------------------------
#DEFINE LCD    1                        ' LCD/Keyboard
#DEFINE PRN    2                        ' Parallele Kom.
#DEFINE RTC    3                        ' Echtzeituhr
#DEFINE PWM1   4                        ' Pulsweitenmodulation (1)
#DEFINE SER    5                        ' Serielle Kom.
#DEFINE AD1    6                        ' Analog-In (1)
#DEFINE AD2    7                        ' Analog-In (2)
#DEFINE PWM2   8                        ' Pulsweitenmodulation (2)
#DEFINE LCD2   9                        ' Grafik-LCD
#DEFINE PARIN  10                       ' Paralleler Eingang
#DEFINE IPL1   11                       ' Puls-In
#DEFINE OPL1   12                       ' Puls-Out
#DEFINE TA     13                       ' Timer A
#DEFINE CNT    14                       ' Zaehler
#DEFINE ENC    15                       ' Encoder
#DEFINE FRQ    16                       ' Frequenzmesser
#DEFINE IPL2   17                       ' Puls-In m. TIMERA
#DEFINE OPL2   18                       ' Puls-Out m. TIMERA
#DEFINE TMEM   19                       ' TouchMemory
#DEFINE KEYB1  20                       ' MF-II-Tastatur
#DEFINE CAN    21                       ' CAN-Bus
#DEFINE SER2   22                       ' Soft-Serielle
#DEFINE AD3    23                       ' Analog-In (3)
#DEFINE AD4    24                       ' Analog-In (4)
#DEFINE MULPO  25                       ' Multi-PulseOut
#DEFINE PS2    26                       ' PS2-Ausgabe
#DEFINE PWMX   27                       ' PWM-Ausgabe (einst. Freq.)
#DEFINE SER4   28                       ' Serielle Kom. (DACC)
#DEFINE SHI    29                       ' Shift-In
#DEFINE SMEDIA 30                       ' SmartMedia
#DEFINE STRO1  31                       ' Serielle Ausgabe (strobed)
#DEFINE XUART  33			' Serielle Kom. mit XUART

'---------------------------------------------------------------------
' Logik-Symbole: JA=0, NEIN=255
'---------------------------------------------------------------------
#DEFINE JA   0                          ' ja
#DEFINE NEIN 0FFh                       ' nein
#DEFINE YES  0                          ' yes
#DEFINE NO   0FFh                       ' no


'---------------------------------------------------------------------
' LCD1.TDD Installationsparameter
'---------------------------------------------------------------------
#DEFINE KB_YES 1
#DEFINE KB_NO 0
#DEFINE LCD_YES 0
#DEFINE LCD_NO 0FFH

'---------------------------------------------------------------------
' Seriell: Baudraten / verfuegbare Standardwerte intern (Axx-Module)
'---------------------------------------------------------------------
#DEFINE BD_50        0  ' 00       50 Bd
#DEFINE BD_75        1  ' 01       75 Bd
#DEFINE BD_110       2  ' 02      110 Bd
#DEFINE BD_150       3  ' 03      150 Bd
#DEFINE BD_200       4  ' 04      200 Bd
#DEFINE BD_300       5  ' 05      300 Bd <-- avail / verfuegbar
#DEFINE BD_600       6  ' 06      600 Bd <-- avail / verfuegbar
#DEFINE BD_900       7  ' 07      900 Bd
#DEFINE BD_1_200     8  ' 08    1.200 Bd <-- avail / verfuegbar
#DEFINE BD_1_800     9  ' 09    1.800 Bd
#DEFINE BD_2_400    10  ' 0A    2.400 Bd <-- avail / verfuegbar
#DEFINE BD_3_600    11  ' 0B    3.600 Bd
#DEFINE BD_4_800    12  ' 0C    4.800 Bd <-- avail / verfuegbar
#DEFINE BD_7_200    13  ' 0D    7.200 Bd
#DEFINE BD_9_600    14  ' 0E    9.600 Bd <-- avail / verfuegbar
#DEFINE BD_14_400   15  ' 0F   14.400 Bd
#DEFINE BD_19_200   16  ' 10   19.200 Bd <-- avail / verfuegbar
#DEFINE BD_28_800   17  ' 11   28.800 Bd
#DEFINE BD_38_400   18  ' 12   38.400 Bd <-- avail / verfuegbar
#DEFINE BD_57_600   19  ' 13   57.600 Bd
#DEFINE BD_76_800   20  ' 14   76.800 Bd <-- avail / verfuegbar
#DEFINE BD_115_200  21  ' 15  115.200 Bd
#DEFINE BD_153_600  22  ' 16  153.600 Bd <-- avail / verfuegbar
#DEFINE BD_230_400  23  ' 17  230.400 Bd
#DEFINE BD_307_200  24  ' 18  307.200 Bd
#DEFINE BD_460_800  25  ' 19  460.800 Bd
#DEFINE BD_614_400  26  ' 1A  614.400 Bd <-- in SER4 verfuegbar
'---------------------------------------------------------------------
' Seriell: Data-Bit / Parity
' in SER4 nur 8-Bit
'---------------------------------------------------------------------
#DEFINE DP_7N        0  ' 7 Data, No Parity <-- avail / verfuegbar
#DEFINE DP_7E        1  ' 7 Data, Even      <-- avail / verfuegbar
#DEFINE DP_7O        2  ' 7 Data, Odd       <-- avail / verfuegbar
#DEFINE DP_8N        3  ' 8 Data, No Parity <-- avail / verfuegbar
#DEFINE DP_8E        4  ' 8 Data, Even      <-- avail / verfuegbar
#DEFINE DP_8O        5  ' 8 Data, Odd       <-- avail / verfuegbar
#DEFINE DP_9N        6  ' 9 Data, No Parity <-- avail / verfuegbar
#DEFINE DP_9E        7  ' 9 Data, Even      <-- avail / verfuegbar
#DEFINE DP_9O        8  ' 9 Data, Odd       <-- avail / verfuegbar

#DEFINE AVAIL_BAUD  "0506080A0C0E10121416"%  ' avail. Baud-Index Conv.
#DEFINE AVAIL_DPAR  "000102030405060708"%    ' Data-/Parity Ind. Conv.


'---------------------------------------------------------------------
' Definitionen fuer ePort-Benutzung  (mit geaenderten Parametern)
'---------------------------------------------------------------------
#DEFINE ACT      1                      ' Kommando: Aktivitaets-Flag
#DEFINE ACTIVE   1
#DEFINE NOACTIVE 0

#DEFINE BUSL 2                          ' Datenbus der erweit. I/O
#DEFINE CTRLL 3                         ' Steuerleitungen
#DEFINE DCLKBMASK 4                     ' Bitmaske fuer DCLK
#DEFINE ACLKBMASK 5                     ' Bitmaske fuer ACLK
#DEFINE INEBMASK 6                      ' Bitmaske fuer INE

#DEFINE PHYSOFFS 7                      ' Beschreibung
#DEFINE NROFOUT  8                      ' siehe Handbuch
#DEFINE LASTLADR 10                     '
#DEFINE INITIAL  11                     '


'---------------------------------------------------------------------
' Definitionen fuer Power-ON  (mit geaenderten Parametern)
'---------------------------------------------------------------------
#DEFINE RAMTEST          101            ' setze Optionen zu RAM-Test
#DEFINE RAMTST_NO          0            ' keinen RAM-Test
#DEFINE RAMTST_FRAGM       1            ' fragmentarischen RAM-Test
#DEFINE RAMTST_QUICK       2            ' schnellen RAM-Test
#DEFINE RAMTST_FULL        3            ' vollen RAM-Test

#DEFINE FLASHTEST        104            ' setze Optionen zu FLASH-Test
#DEFINE FLASHTST_NO        0            ' keinen FLASH-Test
#DEFINE FLASHTST_FRAGM     1            ' fragmentarischen FLASH-Test
#DEFINE FLASHTST_QUICK     2            ' schnellen FLASH-Test
#DEFINE FLASHTST_FULL      3            ' vollen FLASH-Test

#DEFINE SYSTEST          102            ' setze Optionen zu SYS-Test
#DEFINE SYSTST_MIN         1            ' minmalen SYS-Test
#DEFINE SYSTST_STANDARD    2            ' Standard SYS-Test
#DEFINE SYSTST_INTENSIV    3            ' intensiven SYS-Test

#DEFINE P_ON_DELAY       103            ' setze Power-ON-Delay
                                        ' 1000 = ca. 1sec

'---------------------------------------------------------------------
' Tasks
'---------------------------------------------------------------------
#DEFINE THIS_TASK -1                    ' akt. Task


'---------------------------------------------------------------------
' Div. mathematische Konstanten
'---------------------------------------------------------------------
#DEFINE MC_E         2.71828182845904523536
#DEFINE MC_LOG2E     1.44269504088896340736
#DEFINE MC_LOG10E    0.434294481903251827651
#DEFINE MC_LN2       0.693147180559945309417
#DEFINE MC_LN10      2.30258509299404568402
#DEFINE MC_PI        3.14159265358979323846
#DEFINE MC_PI_2      1.57079632679489661923
#DEFINE MC_PI_4      0.785398163397448309616
#DEFINE MC_1_PI      0.318309886183790671538
#DEFINE MC_2_PI      0.636619772367581343076
#DEFINE MC_1_SQRTPI  0.564189583547756286948
#DEFINE MC_2_SQRTPI  1.12837916709551257390
#DEFINE MC_SQRT2     1.41421356237309504880
#DEFINE MC_SQRT_2    0.707106781186547524401


'---------------------------------------------------------------------
' Converter Strings
'---------------------------------------------------------------------
STRING NO_CTRL7$ (128)  ' keine CTRL-Zeichen -> zu BLANK convertieren


'---------------------------------------------------------------------
' Eingangsparameter fuer Funktion SYSVARN:
'---------------------------------------------------------------------
#DEFINE RE_ID 00             ' letzter Run-Time-Error-Code
                             ' in der Task TaskNr
#DEFINE RE_CNT 01            ' Run-Time-Error-Zaehlerstand
#DEFINE RE_SEMA 02           ' Akt-ErrFlag (0=ok, 1=error)
#DEFINE RE_IDRES 15          ' setzt Error-Flag zurueck
                             ' und liefert ErrCode zurueck
#DEFINE CALL_LEVEL 16        ' Stack-Verschachtelungstiefe
#DEFINE DSTACK_FILL 17       ' Stack-Fuellung in Bytes
#DEFINE DSTACK_FREE 18       ' freier Stack-Platz in Bytes
#DEFINE DSTACK_SIZE 19       ' Stack-Groesse in Bytes
#DEFINE DRAM 30              ' DRAM-Groessen:
                             ' 0: Gesamt-DRAM im System
                             ' 1: Gesamt-DRAM fuer BASIC
                             ' 2: DRAM belegt von BASIC
                             ' 3: DRAM noch frei
#DEFINE SRAM 31              ' SRAM-Groessen
                             ' 0: Gesamt-SRAM im System
                             ' 1: Gesamt-SRAM fuer BASIC
                             ' 2: SRAM belegt von BASIC
                             ' 3: SRAM noch frei
#DEFINE FLASH_CHIPS 32       ' Anzahl der Flash-Chips
#DEFINE FLASH_SIZE 33        ' Groesse Flash-Ch. in Bytes
#DEFINE FLASH_SEC 34         ' Anzahl Sektoren pro Chip
#DEFINE FLASH_SSIZE 35       ' Flash-Sektorgroesse
#DEFINE FLASH_ASEC 36        ' Anzahl der Flash-Sektoren
#DEFINE FLASH_GSIZE 37       ' Groesse des Flashs in Byte
#DEFINE FLASH_DSEC 38        ' Anzahl der Flash-Sektoren
                             ' fuer User-Daten
#DEFINE FLASH_DSIZE 39       ' Groesse des Flashspeichers
                             ' in Bytes fuer User-Daten
#DEFINE FLASH_DMODE 40       ' 0=wait, 1=cont
#DEFINE ACT_TASK 48          ' aktuelle Task-Nummer
#DEFINE TASK_PRIO 49         ' aktuelle Task-Prioritaet
#DEFINE SUM_PRIO 50          ' Summe aller T.-Prioritaeten
#DEFINE NR_OF_TASKS 51       ' Anzahl Tasks im Programm
#DEFINE NR_ACT_TASKS 52      ' Anzahl aktiver Tasks
#DEFINE START_INFO 65        ' Neustart erfolgte durch:
                             ' 0: Power-ON / Reset
                             ' 1: Watchdog
                             ' 2: Illegaler Befehl (BASIC)
                             ' 3: System Error
#DEFINE SYS_SPEED 66         ' System Geschwindigkeit:
                             ' 0: volle Geschwindigkeit
                             ' 1: Low-Power-Mode-1
                             ' 2: Ultra-Low-Power-Mode-2
#DEFINE TIGER_MODE 67        ' Tiger-Modus:
                             ' 0: RUN-Mode
                             ' 1: PC-Mode =Debug-MODE
#DEFINE TIGER_VERS 68        ' Tiger-Version
#DEFINE TIGER_MODULE 69      ' Tiger-Modul Typ:
                             ' 0 = Modul-Familie A
#DEFINE WD_STAT 70           ' akt. Watchdog-Status
                             ' 0 ... 6
#DEFINE WD_MSTAT 71          ' Watchdog-MAX-State
                             ' 0 ... 6


'---------------------------------------------------------------------
' Echtzeitfehler (Funktionsergebnisse), gemeldet von SYSVARN:
'---------------------------------------------------------------------
#DEFINE RE_TASK_NAVAIL 07    ' Task-Nr. nicht verfuegbar
#DEFINE RE_STR_OVL 08        ' String-Laenge ueberschritten
#DEFINE RE_PARAM_ILL 11      ' Parameter-Wert ist unzulaessig
#DEFINE RE_DEVNR 32          ' Geraete-Kanal-Nr. fehlerhaft
#DEFINE RE_PORTADR 33        ' Port-Adress-Fehler
#DEFINE RE_DEV 34            ' Geraete-Fehler
#DEFINE RE_NO_PACC 35        ' I/O-Pin(s) bereits belegt
#DEFINE RE_NO_DEVN_INST 38   ' Device-Treiber nicht installiert
#DEFINE RE_NO_FLASH 48       ' FLASH: nicht vorhanden
#DEFINE RE_FLASH_WR 49       ' FLASH: Schreibfehler
#DEFINE RE_FLASH_BUSY 50     ' FLASH: nicht bereit
#DEFINE RE_FLASH_ADR 52      ' FLASH: Adress-Fehler
#DEFINE RE_FLASH_PEEKL 53    ' FLASH: PEEK-Laenge ungueltig
                             ' z.B. 0 oder bei REAL-Wert<>8
#DEFINE RE_FLASH_TOT 55      ' FLASH: Timeout
#DEFINE RE_FIFO 64           ' FIFO-Fehler
#DEFINE RE_FIFO_EMPTY 65     ' FIFO ist leer
#DEFINE RE_FIFO_FULL 66      ' FIFO ist voll


'---------------------------------------------------------------------
' Eingangsparameter fuer Funktion SYSVAR$:
'---------------------------------------------------------------------
#DEFINE RE_T_STRI 00         ' letzter Run-Time-Error-Text
                             ' in der Task TaskNr
#DEFINE RE_C_STRI 01         ' Run-Time-Error-Text von
                             ' Error-Code

'---------------------------------------------------------------------
' Eingangsparameter fuer Funktion SET_SYSVARN:
'---------------------------------------------------------------------
#DEFINE SHIFT_SLOWER 0       ' Setzt einen Parameter der Funktionen
                             ' SHIFT_IN und SHIFT_OUT, um die
                             ' Clock-Pulse dieser Funktionen zu
                             ' verlangsamen.
                             ' Wertebereich: 0...15, Standard: 0


'---------------------------------------------------------------------
' Meldungen der TAN-Funktionen
'---------------------------------------------------------------------
#DEFINE TAN_OK 0             ' Meldung o.k.
#DEFINE TAN_ERR_NF -1        ' Fehler: nicht gefinden
#DEFINE TAN_ERR_USED -2      ' Fehler: TAN bereits verwendet
#DEFINE TAN_ERR_DELETED -3   ' Fehler: TAN bereits geloescht
#DEFINE TAN_ERR_NA -4        ' Fehler: TAN-Funktion nicht ausfuehrbar
                             ' in dieser Modulversion
#DEFINE TAN_ERR_INV -5       ' Fehler: TAN-Tabelle ungueltig
#DEFINE TAN_ERR_FLASH -6     ' Fehler: Flash-Problem
#DEFINE TAN_ERR_PARA -7      ' Fehler: Parameter ungueltig
#DEFINE TAN_ERR_SHORT -8     ' Fehler: TAN-String zu kurz
#DEFINE TAN_ERR_LONG -9      ' Fehler: TAN-String zu lang
#DEFINE TAN_ERR_NOFL -10     ' Fehler: zuwenig Platz im Flash
#DEFINE TAN_ERR_INVTYP -11   ' Fehler: ungueltiger Typ

' for TAN_CHK:
#DEFINE TAN_UNUSED 00000011b ' Flagbytes: unbenutzte TAN
#DEFINE TAN_USED 00000010b   ' Flagbytes: benutzte TAN
#DEFINE TAN_DELETED 00000001b' Flagbytes: geloeschte TAN
#DEFINE TAN_UD 00000000b     ' Flagbytes: benutzte + geloeschte TAN

#define TANFLAG 9bh          ' Wert des TAN Flag-Bytes


'---------------------------------------------------------------------
' Warning-Codes der Device-Treiber
'---------------------------------------------------------------------
#DEFINE DEVW_FAULT         1 ' Device ist beschftigt (busy)
#DEFINE DEVW_INBU_OVL      2 ' Eingangspuffer-berlauf
#DEFINE DEVW_ILL_CHR       3 ' Unerlaubtes Zeichen
#DEFINE DEVW_OBU_SPACE     4 ' Nicht gengend Platz im Ausgabepuffer
#DEFINE DEVW_NO_INPUT      5 ' Keine Input-Daten vorhanden


'---------------------------------------------------------------------
' Fehler-Codes der Device-Treiber
'---------------------------------------------------------------------
#DEFINE DEVE_FAULT       128 ' Fehler - allgemein
#DEFINE DEVE_FATAL       129 ' Fatal Device-Error, schwerer,
                             ' grundsaetzlicher Device-Fehler,
                             ' (z.B. Install war erfolglos)
#DEFINE DEVE_FUNC_NAV    130 ' Funktion nicht verfgbar
#DEFINE DEVE_SADR_NAV    131 ' Sekundr-ADR nicht verfgbar
#DEFINE DEVE_SFCODE_NAV  132 ' SYSTEM-Function-Code nicht verfgbar
#DEFINE DEVE_UFCODE_NAV  133 ' USER-Function-Code nicht verfgbar
#DEFINE DEVE_TOUT1       134 ' Timeout-1 ist eingetreten
#DEFINE DEVE_TOUT2       135 ' Timeout-2 ist eingetreten
#DEFINE DEVE_TVERS       136 ' Tiger-VERSION ist zu alt
#DEFINE DEVE_PARAM_WERT  137 ' Parameter-Wert nicht mglich
#DEFINE DEVE_MANY        138 ' Zu viele Parameter
#DEFINE DEVE_MISS        139 ' Parameter fehlt
#DEFINE DEVE_INT_NAV     140 ' INTERRUPT nicht verfgbar
#DEFINE DEVE_TIM_NAV     141 ' TIMER nicht verfgbar
#DEFINE DEVE_RAM_NAV     142 ' RAM nicht verfgbar
#DEFINE DEVE_RESO_NAV    143 ' RESOURCE nicht verfgbar
#DEFINE DEVE_FREQ_NAV    144 ' FREQUENZ nicht verfgbar
#DEFINE DEVE_SIZ         145 ' Parameter-Gren-Fehler
#DEFINE DEVE_PARTYP      146 ' Paramater-Typ Fehler
#DEFINE DEVE_IOINST_NAV  147 ' I/O-Instruktion nicht verfgbar
#DEFINE DEVE_NOW_DIS     148 ' Funktion-ist-JETZT-gesperrt
#DEFINE DEVE_NO_SPACE    149 ' kein Platz im Zielpuffer
#DEFINE DEVE_LOAD        150 ' zu hohe CPU-Leistung angefordert
#DEFINE DEVE_SIZE_NAV    151 ' Diese Variablengre nicht verfgbar
#DEFINE DEVE_RESO_NINST  152 ' Ressource nicht installiert
#DEFINE DEVE_RESO_MISSIO 153 ' I/O-Channel nicht vorhanden
#DEFINE DEVE_ONLY_1HISP  154 ' Nur 1 High-Speed-Kanal verfgbar
#DEFINE DEVE_IO_VIOLAT   155 ' 'I/O-Pin exclusive'-Verletzung
#DEFINE DEVE_INP_TOF     156 ' Input-Data zum Flash nicht mglich
#DEFINE DEVE_NOFLADR     157 ' ungltige Flash-Adresse
#DEFINE DEVE_1DACC       158 ' Nur 1 High-Speed-Kanal verfgbar

